<template>
    <div class="timer">
        <div class="timer__inner" v-if="time">        
            <div class="timer__item">
                <div class="timer__box timer__days">{{days}}</div> 
                <div class="timer__note">д.</div>
            </div>
            <div class="timer__delimiter"></div>

            <div class="timer__item">
                <div class="timer__box timer__hours">{{hours}}</div>
                <div class="timer__note">ч.</div>
            </div>
            <div class="timer__delimiter"></div>

            <div class="timer__item">
                <div class="timer__box timer__minutes">{{minutes}}</div> 
                <div class="timer__note">м.</div>
            </div>
            <div class="timer__delimiter"></div>

            <div class="timer__item">
                <div class="timer__box timer__minutes">{{seconds}}</div> 
                <div class="timer__note">с.</div>
            </div>
        </div>
        <div class="timer__inner" v-else>
            Акция закончилась
        </div>
    </div>
</template>
<script>
export default {
    props: ['end_date'],
    data() {
        return {
            days: null,
            hours: null,
            minutes: null,
            seconds: null,
            time: null,
        }
    },
    methods : {
        getTimeRemaining(endtime) {
            if (!endtime) return false;

            let t = Date.parse(endtime) - Date.parse(new Date());
            if (t <= 0) return false;

            let seconds = Math.floor( (t/1000) % 60 );
            let minutes = Math.floor( (t/1000/60) % 60 );
            let hours = Math.floor( (t/(1000*60*60)) % 24 );
            let days = Math.floor( t/(1000*60*60*24) );
            return {
                'total': t,
                'days': days,
                'hours': hours,
                'minutes': minutes,
                'seconds': seconds
            };
        },
        startTimer: function() {
            let timeinterval = setInterval(() => {
                let t = this.getTimeRemaining(this.end_date);

                this.time = t;
                this.days = t.days;
                this.hours = t.hours;
                this.minutes = t.minutes;
                this.seconds = t.seconds;

                if(t.total<=0){
                    clearInterval(timeinterval);
                }
            }, 1000);
        }
    },
    mounted() {
        this.startTimer()
    },
}
</script>  